import os
import socket
import struct
import array

class Pinger(object):
	def __init__(self,timeout=3):
	    self.timeout = timeout
	    self.__id = os.getpid()
	    self.__data = struct.pack('h',1)

	def __icmpSocket(self):
	    icmp = socket.getprotobyname("icmp")
	    sock = socket.socket(socket.AF_INET,socket.SOCK_RAW,icmp)
	    return sock

	def __doCksum(self,packet):
	    words = array.array('h',packet)
	    sum = 0
	    for word in words:
		sum += (word & 0xffff)
	    sum = (sum >> 16) + (sum & 0xffff)
	    sum += (sum >> 16)
	    return (~sum) & 0xffff

	def __icmpPacket(self):
	    header = struct.pack('bbHHh',8,0,0,self.__id,0)
	    packet = header + self.__data
	    cksum = self.__doCksum(packet)
	    header = struct.pack('bbHHh',8,0,cksum,self.__id,0)
	    return header + self.__data

	def sendPing(self,target_host):

	    try:
		socket.gethostbyname(target_host)

		sock = self.__icmpSocket
		sock.settimeout(self.timeout)

		packet = self.__icmpPacket

		sock.sendto(packet,(target_host,1))
		ac_ip = sock.recvfrom(1024)[1][0]
		print '[+] %s active'%(ac_ip)
	    except Exception,e:
		sock.close()

s = Pinger()

s.sendPing('192.168.1.103')
	
